/*
	Trig Wars.
	Copyright (c) 2008, Darragh Coy.
	All rights reserved.
	Original work(s), source code & author(s) details available at: http://www.darraghcoy.com

	Redistribution and use in source and binary forms, with or without modification, are permitted 
	provided that the following conditions are met:

		* 	Redistributions of source code must retain the above copyright notice, this list of 
			conditions and the following disclaimer.
		* 	Redistributions in binary form must reproduce the above copyright notice, this list of 
			conditions and the following disclaimer in the documentation.
		* 	Neither the name of the author nor the names of contributors may be used to endorse or 
			promote products derived from this software without specific prior written permission.
		* 	The use of any third party libraries, modules or data files provided with the source 
			form of the program must follow and respect the individual licensing terms of these 
			components. You do not have permission to modify or circumvent the licensing terms for 
			provided third party components unless the third party licenses specifically allow this. 
			If you do not agree to the terms of provided third party components then you do not have 
			permission to use them in your derived work(s).
		* 	The terms of this license do not apply to separate (but related) distributions if supplied 
			by the author(s), only to the contents of this source distribution, derived works, and the 
			binaries produced by either modified or unmodified versions of the source code. The terms 
			of this license do not also apply to any third party libraries or components provided with 
			the source distribution. Such third party elements are licensed under their own separate 
			agreements.

	THIS SOFTWARE IS PROVIDED BY DARRAGH COY ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, 
	BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
	ARE DISCLAIMED. IN NO EVENT SHALL DARRAGH COY BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
	EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
	OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
	OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
	IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef GAME_TYPES_H
#define GAME_TYPES_H

//=====================================================================================================================
/// @brief		This file has includes for all of the types used by the game. These include basic types as well 
///				as math types such as vectors.
//=====================================================================================================================

// Math types:

#include "Base\Math\Float.h"
#include "Base\Math\Vector2.h"
#include "Base\Math\Vector3.h"
#include "Base\Math\Vector4.h"
#include "Base\Math\Matrix2.h"
#include "Base\Math\Matrix3.h"
#include "Base\Math\Matrix4.h"
#include "Base\Math\Color.h"
#include "Base\Math\Angle.h"

// Math type definitions

namespace Game
{
	typedef Game::Vector2<float> Vec2f;
	typedef Game::Vector2<int> Vec2i;
	typedef Game::Vector2<unsigned> Vec2u;
	typedef Game::Vector2<short> Vec2s;
	typedef Game::Vector2<unsigned short> Vec2us;
	typedef Game::Vector2<char> Vec2b;
	typedef Game::Vector2<unsigned char> Vec2ub;

	typedef Game::Vector3<float> Vec3f;
	typedef Game::Vector3<int> Vec3i;
	typedef Game::Vector3<unsigned> Vec3u;
	typedef Game::Vector3<short> Vec3s;
	typedef Game::Vector3<unsigned short> Vec3us;
	typedef Game::Vector3<char> Vec3b;
	typedef Game::Vector3<unsigned char> Vec3ub;
	
	typedef Game::Vector4<float> Vec4f;
	typedef Game::Vector4<int> Vec4i;
	typedef Game::Vector4<unsigned> Vec4u;
	typedef Game::Vector4<short> Vec4s;
	typedef Game::Vector4<unsigned short> Vec4us;
	typedef Game::Vector4<char> Vec4b;
	typedef Game::Vector4<unsigned char> Vec4ub;

	typedef	Game::Matrix2<float> Matrix2f;
	typedef	Game::Matrix3<float> Matrix3f;
	typedef	Game::Matrix4<float> Matrix4f;
};

#endif